( Lights Program for 3-instruction Forth on Atmel 328 Arduino Nano )
\ Assad Ebrahim, assadebrahim2000@gmail.com, http://www.mathscitech.org/articles
\ 2020-06-22

( * WORDS FOR LIGHT LED BOARD * )

: all-out ( -- ) cr ." ..." cr 13 2 do i out loop ;
: all-high 13 2 do i high loop ;
: all-low ( -- ) 13 2 do i low loop ;

\ Solution 1 - brute force
\ : yellows-high 3 high 5 high 7 high 9 high 11 high ;
\ : yellows-low 3 low 5 low 7 low 9 low 11 low ;
\ Solution 2 - loop
\ : yellows-high ( -- )   3 5 7 9 11  5 0 do high loop ; 
\ : yellows-low ( -- )   3 5 7 9 11  5 0 do low loop ; 
\ Solution 3 - factor
: yellows 3 5 7 9 11 ;
: yellows-high ( -- )   yellows 5 0 do high loop ; 
: yellows-low ( -- )   yellows  5 0 do low loop ; 

: reds 2 4 6 8 10 12 ;
: reds-high reds 6 0 do hi loop ;
: reds-low reds 6 0 do low loop ;

: flash all-high 200 ms all-low 200 ms ;
: n-flash ( n -- ) 0 do flash loop ;  \ ex: 10 n-flash
: flash-yellows   yellows-high 200 ms yellows-low 200 ms ;
: flash-reds      reds-high 200 ms reds-low 200 ms ;
: n-bounce ( n -- ) 0 do flash flash flash-yellows flash-reds flash-yellows flash-reds flash loop ;

: kit-delay 25 ms ;  \ delay for successive changes to look smooth
: l2r-high 13 2 do i hi kit-delay loop ;
: l2r-low  13 2 do i low kit-delay loop ;
: r2l-high 13 2 do 14 i - hi kit-delay loop ;  \ note: only gets to 12
: r2l-low 13 2 do 14 i - low kit-delay loop ;
: n-kit  ( n -- ) 0 do l2r-high l2r-low r2l-high r2l-low loop ;
\ knight-rider effect
: l2r-vivid 2 high 3 high 13 4 do kit-delay i 2 - low i high loop ; 
: r2l-vivid 12 high 11 high 13 4 do kit-delay 16 i - low 16 i - 2 - high loop ; 
: vivid l2r-vivid 60 ms r2l-vivid 60 ms ;  \ a little stickier feel at the ends
: n-vivid ( n -- ) 0 do vivid loop all-low ;

\ colors
: colors reds-high 60 ms yellows-low 80 ms yellows-high 60 ms reds-low 80 ms ;
: n-colors 0 do colors loop all-low ;

: showtime all-low 10 n-flash 10 n-colors 5 n-vivid 10 n-colors 5 n-vivid 10 n-flash all-high ;

: help-lights
    cr cr 
    cr ."  => LEDs & BUZZERS:  include 3iLights.fs"
    cr ."       all-out  - for light-board"
    cr ."       2 high        - sends voltage to pin 2  (choose pins 2 through 12)"
    cr ."       2 low         - sends voltage to pin 2  (choose pins 2 through 12)"
;
\ =====================
help-lights
